
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MachinesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.create(
            {
                id: data.id || undefined,
        
        machine_name: data.machine_name
        ||
        null
            ,
            
        machine_code: data.machine_code
        ||
        null
            ,
            
        manufacturer: data.manufacturer
        ||
        null
            ,
            
        model: data.model
        ||
        null
            ,
            
        serial_number: data.serial_number
        ||
        null
            ,
            
        commissioned_at: data.commissioned_at
        ||
        null
            ,
            
        machine_status: data.machine_status
        ||
        null
            ,
            
        criticality: data.criticality
        ||
        null
            ,
            
        rated_capacity_per_hour: data.rated_capacity_per_hour
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await machines.setWork_center( data.work_center || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.machines.getTableName(),
                belongsToColumn: 'manuals',
                belongsToId: machines.id,
            },
            data.manuals,
            options,
        );
        

        return machines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const machinesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                machine_name: item.machine_name
            ||
            null
            ,
            
                machine_code: item.machine_code
            ||
            null
            ,
            
                manufacturer: item.manufacturer
            ||
            null
            ,
            
                model: item.model
            ||
            null
            ,
            
                serial_number: item.serial_number
            ||
            null
            ,
            
                commissioned_at: item.commissioned_at
            ||
            null
            ,
            
                machine_status: item.machine_status
            ||
            null
            ,
            
                criticality: item.criticality
            ||
            null
            ,
            
                rated_capacity_per_hour: item.rated_capacity_per_hour
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const machines = await db.machines.bulkCreate(machinesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < machines.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.machines.getTableName(),
                    belongsToColumn: 'manuals',
                    belongsToId: machines[i].id,
                },
                data[i].manuals,
                options,
            );
        }
        

        return machines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const machines = await db.machines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.machine_name !== undefined) updatePayload.machine_name = data.machine_name;
        
        
        if (data.machine_code !== undefined) updatePayload.machine_code = data.machine_code;
        
        
        if (data.manufacturer !== undefined) updatePayload.manufacturer = data.manufacturer;
        
        
        if (data.model !== undefined) updatePayload.model = data.model;
        
        
        if (data.serial_number !== undefined) updatePayload.serial_number = data.serial_number;
        
        
        if (data.commissioned_at !== undefined) updatePayload.commissioned_at = data.commissioned_at;
        
        
        if (data.machine_status !== undefined) updatePayload.machine_status = data.machine_status;
        
        
        if (data.criticality !== undefined) updatePayload.criticality = data.criticality;
        
        
        if (data.rated_capacity_per_hour !== undefined) updatePayload.rated_capacity_per_hour = data.rated_capacity_per_hour;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await machines.update(updatePayload, {transaction});

        
        
        if (data.work_center !== undefined) {
            await machines.setWork_center(
              
              data.work_center,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.machines.getTableName(),
                belongsToColumn: 'manuals',
                belongsToId: machines.id,
            },
            data.manuals,
            options,
        );
        

        return machines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of machines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of machines) {
                await record.destroy({transaction});
            }
        });


        return machines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.findByPk(id, options);

        await machines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await machines.destroy({
            transaction
        });

        return machines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.findOne(
            { where },
            { transaction },
        );

        if (!machines) {
            return machines;
        }

        const output = machines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.machine_readings_machine = await machines.getMachine_readings_machine({
            transaction
        });
        
        
        output.maintenance_work_orders_machine = await machines.getMaintenance_work_orders_machine({
            transaction
        });
        
        
        
        
        output.work_order_operations_assigned_machine = await machines.getWork_order_operations_assigned_machine({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.alerts_related_machine = await machines.getAlerts_related_machine({
            transaction
        });
        
        
        
        
        output.work_center = await machines.getWork_center({
            transaction
        });
        
        
        output.manuals = await machines.getManuals({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.work_centers,
        as: 'work_center',
        
        where: filter.work_center ? {
          [Op.or]: [
            { id: { [Op.in]: filter.work_center.split('|').map(term => Utils.uuid(term)) } },
            {
              work_center_name: {
                [Op.or]: filter.work_center.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'manuals',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.machine_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'machine_name',
                        filter.machine_name,
                    ),
                };
            }
            
            if (filter.machine_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'machine_code',
                        filter.machine_code,
                    ),
                };
            }
            
            if (filter.manufacturer) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'manufacturer',
                        filter.manufacturer,
                    ),
                };
            }
            
            if (filter.model) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'model',
                        filter.model,
                    ),
                };
            }
            
            if (filter.serial_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'serial_number',
                        filter.serial_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.commissioned_atRange) {
                const [start, end] = filter.commissioned_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    commissioned_at: {
                    ...where.commissioned_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    commissioned_at: {
                    ...where.commissioned_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.rated_capacity_per_hourRange) {
                const [start, end] = filter.rated_capacity_per_hourRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rated_capacity_per_hour: {
                    ...where.rated_capacity_per_hour,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rated_capacity_per_hour: {
                    ...where.rated_capacity_per_hour,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.machine_status) {
                where = {
                    ...where,
                machine_status: filter.machine_status,
            };
            }
            
            if (filter.criticality) {
                where = {
                    ...where,
                criticality: filter.criticality,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.machines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'machines',
                        'machine_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.machines.findAll({
            attributes: [ 'id', 'machine_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['machine_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.machine_name,
        }));
    }

    
};

